'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getScrapers;

var _fp = require('lodash/fp');

var _fp2 = _interopRequireDefault(_fp);

var _filesParser = require('./lib/filesParser.js');

var _filesParser2 = _interopRequireDefault(_filesParser);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ONE_HOUR = 3600000;

var initializeScraper = function initializeScraper(scraper) {
  // eslint-disable-next-line no-param-reassign
  scraper.timeBetween = scraper.timeBetween || ONE_HOUR;

  if (!scraper.name) {
    throw new Error('name must exist');
  }

  if (typeof scraper.timeBetween !== 'number') {
    throw new Error('timeBetween must be a number');
  }

  /* eslint-disable no-param-reassign, no-console */
  scraper.log = (0, _debug2.default)('scraperjs ' + scraper.name + ':log');
  scraper.warn = (0, _debug2.default)('scraperjs ' + scraper.name + ':warn');
  scraper.error = (0, _debug2.default)('scraperjs ' + scraper.name + ':error');
  /* eslint-enable no-param-reassign, no-console */

  return scraper;
};

function getScrapers(files) {
  return (0, _filesParser2.default)(files).then(_fp2.default.map(function (file) {
    return require(file);
  })) // eslint-disable-line global-require
  .then(_fp2.default.map(function (scraper) {
    return scraper.default || scraper;
  })).then(_fp2.default.map(initializeScraper));
}