'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /* eslint-env browser */

var _seleniumWebdriver = require('selenium-webdriver');

var _seleniumWebdriver2 = _interopRequireDefault(_seleniumWebdriver);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// const { By, until } = webdriver;

var getNewBrowser = function getNewBrowser() {
  return _seleniumWebdriver2.default.promise.createFlow(function (controlFlow) {
    return new _seleniumWebdriver2.default.Builder().setControlFlow(controlFlow).forBrowser(process.env.HEADLESS ? 'phantomjs' : process.env.BROWSER || 'chrome').build();
  });
};

var Browser = function () {
  function Browser(driver) {
    _classCallCheck(this, Browser);

    this.driver = driver;
    // @todo make this configurable, 15 minutes is too long for most things,
    // and probably not enough for all use cases.
    driver.manage().timeouts().setScriptTimeout(15 * 60 * 1000);
  }

  _createClass(Browser, [{
    key: 'navigate',
    value: function navigate(url) {
      this._currentUrl = url;
      return _bluebird2.default.join(this.driver.get(url));
    }
  }, {
    key: 'executeScript',
    value: function executeScript(script) {
      return _bluebird2.default.join(this.driver.executeScript(script));
    }
  }, {
    key: 'executeAsyncScript',
    value: function executeAsyncScript() {
      var _driver;

      return _bluebird2.default.join((_driver = this.driver).executeAsyncScript.apply(_driver, arguments));
    }
  }, {
    key: 'quit',
    value: function quit() {
      this.driver.quit();
    }
  }]);

  return Browser;
}();

exports.default = function () {
  return getNewBrowser().then(function (driver) {
    return new Browser(driver);
  });
};