"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = duringFactory;
function duringFactory() {
  return function during(expression) {
    var delay = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
    var errorMessage = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "Expression was not true after " + delay + "ms";

    return new Promise(function (resolve, reject) {
      window.setTimeout(function () {
        if (expression()) {
          resolve(true);
          return;
        }
        reject(new Error(errorMessage));
      }, delay);
    });
  };
}